/*
 * $Id:$
 *
 * Copyright (C) 2004 Essence project.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __ESSENCE_DB_H
#define __ESSENCE_DB_H

#include <Edb.h>
#include <gtk/gtk.h>

enum {
	COL_KEY,
	COL_TYPE,
	COL_VALUE,
	COL_ITEM,
	COL_NUM
};

typedef struct {
	E_DB_File *db;
	char file[PATH_MAX + 1];
	GSList *items;

	GtkNotebook *notebook;
	GtkWidget *notebook_child;
	GtkWidget *tab_label;
	GtkTreeView *tree;
	GtkListStore *store;
	GtkTreeSelection *select;

	GFunc dest_notify;
	gpointer dest_notify_data;
} EssenceDb;

EssenceDb *essence_db_new (GtkNotebook *notebook, const char *file,
                           GFunc dest_notify, gpointer udata);
void essence_db_free (EssenceDb *edb);

bool essence_db_load (EssenceDb *edb);
bool essence_db_save (EssenceDb *edb);
bool essence_db_save_as (EssenceDb *edb, const char *file);

#endif
