/*
 * $Id:$
 *
 * Copyright (C) 2004 Essence project.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __ESSENCE_DB_ITEM_H
#define __ESSENCE_DB_ITEM_H

#include <Edb.h>
#include <gtk/gtk.h>

typedef enum {
	ITEM_TYPE_NONE,
	ITEM_TYPE_INT,
	ITEM_TYPE_FLOAT,
	ITEM_TYPE_STR,
	ITEM_TYPE_NUM
} EssenceDbItemType;

typedef struct {
	E_DB_File *db;
	char key[64];
	EssenceDbItemType type;

	union {
		char s[1024];
		int i;
		float f;
	} data;
} EssenceDbItem;

EssenceDbItem *essence_db_item_new (E_DB_File *db);
void essence_db_item_free (EssenceDbItem *ei);

void essence_db_item_key_set (EssenceDbItem *ei, const char *key);

bool essence_db_item_load (EssenceDbItem *ei);
void essence_db_item_save (EssenceDbItem *ei);

GtkTreeIter essence_db_item_show (EssenceDbItem *ei,
                                  GtkListStore *store);

void essence_db_item_remove (EssenceDbItem *ei);

#endif
