/*
 * $Id:$
 *
 * Copyright (C) 2004 Essence project.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <gtk/gtk.h>
#include <stdio.h>

#include "essence.h"

int main (int argc, char **argv)
{
	Essence *e;
	int i;

	if (!(e = essence_new ()))
		return 1;

	gtk_init (&argc, &argv);

	if (!essence_init (e)) {
		essence_free (e);
		return 1;
	}

	for (i = 1; i < argc; i++)
		essence_load (e, argv[i]);

	gtk_widget_show_all (GTK_WIDGET (e->window));
	gtk_main ();

	/* now free the Essence object and the databases */
	essence_free (e);

	return 0;
}
