/*
 * $Id:$
 *
 * Copyright (C) 2004 Essence project.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <assert.h>

/* This code was copied from OpenBSD's C library (see
 * ftp://ftp.openbsd.org/pub/OpenBSD/src/lib/libc/string/strlcpy.c or
 * alternatively strlcat.c) with minor formatting corrections.
 *
 * Copyright (c) 1998, 2000 Todd C. Miller <Todd.Miller@courtesan.com>
 */
#ifndef HAVE_STRLCPY
size_t strlcpy (char *dst, const char *src, size_t siz)
{
	char *d = dst;
	const char *s = src;
	size_t n = siz;

	/* Copy as many bytes as will fit */
	if (n && --n) {
		do {
			if (!(*d++ = *s++))
				break;
		} while (--n);
	}

	/* Not enough room in dst, add NULL and traverse rest of src */
	if (!n) {
		if (siz)
			*d = 0; /* NUL-terminate dst */

		while (*s++);
	}

	return (s - src - 1); /* count does not include NUL */
}
#endif

bool file_exists (const char *file)
{
	struct stat st = {0};

	assert (file);

	if (!stat (file, &st))
		return S_ISREG (st.st_mode);
	else
		return false;
}
